#include <iostream>
#include <iomanip>
#include <sstream>

int main() {
    int a, b, k, r;
    std::cin >> a >> b >> k >> r;

    double c = static_cast<double>(a) / b;
    std::stringstream ss;
    ss << std::fixed << std::setprecision(r + 10) << c; // Set precision higher to ensure enough digits
    std::string result = ss.str();

    size_t pos = result.find('.');
    if (pos != std::string::npos && pos + k + r < result.size()) {
        std::cout << result.substr(pos + k, r) << std::endl;
    }

    return 0;
}