#include <iostream>
#include <cassert>
#include <vector>
#include <algorithm>

typedef long long ll;
typedef long double ld;

const int BULAN = 2e4;

int main() {
  int a, b;
  ll k;
  int p;
  std::cin >> a >> b >> k >> p;

  std::string s;

  for (int i = 1; i <= BULAN ; i++) {
    int d = a % b;
    a = d * 10;
    s += char(a / b + '0');
  }

  int period = 0;
  bool ok = false;
  while (!ok) {
    period++;
    ok = true;
    for (int i = BULAN - 1; i >= BULAN - period; i--) {
      if (s[i] != s[i - period]) {
        ok = false;
      }
    }
  }

  if (k < BULAN - p) {
    std::cout << s.substr(k - 1, p);
    return 0;
  }

  int sz = period;
  k--;
  k %= sz;

  std::cout << s.substr(k, p);

  return 0;
}
