#include <bits/stdc++.h>
using namespace std;

bitset <30000001> visited_remainder;
bitset <4> digit[30000001];

void encode(bitset <4>& bs, int digit) {
    bs[0] = digit / 1 % 2;
    bs[1] = digit / 2 % 2;
    bs[2] = digit / 4 % 2;
    bs[3] = digit / 8 % 2;
}

int decode(bitset <4> bs) {
    return bs[0] + 2 * bs[1] + 4 * bs[2] + 8 * bs[3];
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    long long a, b, k, p;
    cin >> a >> b >> k >> p;
    long long whole = a / b;
    a %= b;

    long long current = a, br = 0;

    long long start_period = 0, end_period = 0;

    while (1) {
        br++;
        long long dig = current * 10 / b, remainder = current * 10 % b;
        current = remainder;
        encode(digit[br], dig);

        if (visited_remainder[remainder] != 0) {
            end_period = br;
            long long REMAINDER = remainder;

            current = a;
            br = 0;

            while (1) {
                br++;
                long long dig = current * 10 / b, remainder = current * 10 % b;
                current = remainder;
                encode(digit[br], dig);

                if (remainder == REMAINDER) {
                    start_period = br + 1;
                    break;
                }

                visited_remainder[remainder] = br;
            }

            break;
        }

        visited_remainder[remainder] = 1;
    }

    /**
    cout << whole << '.';

    for (int i = 1; i <= end_period; i++) {
        if (i == start_period) cout << '(';
        cout << digit[i];
    }

    cout << ")\n";
    */

    for (long long i = k; i < k + p; i++) {
        if (i < start_period) cout << decode(digit[i]);
        else cout << decode(digit[(i - start_period) % (end_period - start_period + 1) + start_period]);
    }

    return 0;

}
/**
1 4

0 1 (10)
2 2 (20)
5 0 (0)

*/
