#include <iostream>
#include<string>
#include<cmath>
#include<map>
#include<iomanip>
#include<algorithm>
#include<vector>
#include<set>
#include<cstdio>
#include<stack>
#include<ctime>
#include<queue>
#include<deque>
#include<bitset>
#include<random>
#include<fstream>
using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}
ll lcm(ll a, ll b) {
    return a / gcd(a, b) * b;
}
int mod = 98244353;
ll bpow(ll a, ll n, ll m) {
    return n == 0 ? 1 : n % 2 ? bpow(a, n - 1, m) * a % mod : bpow(a * a % mod, n / 2, m);
}
ll inv(ll a) {
    return bpow(a, mod - 2, mod);
}
const int N = 50000001;
//ll f[N];
//ll C(int n, int k) {
//    return f[n] * inv(f[k]) % mod * inv(f[n - k]) % mod;
//}
struct mystring {
    char a[25000001];
    int ptr = 0;
    mystring() {
        fill(a, a + 25000001, 0);
    }
    void operator+= (char c) {
        a[ptr++] = c;
    }
    char operator[](int i) {
        return a[i];
    }
    int size() {
        return ptr;
    }
    void reverse() {
        int i = 0, j = ptr - 1;
        while (i < j) {
            swap(a[i], a[j]);
            ++i;
            --j;
        }
    }
};
vector<int> pfun(mystring& s) {
    int n = s.size();
    vector<int> p(n);
    for (int i = 1; i < n; ++i) {
        int j = p[i - 1];
        while (j && s[j] != s[i]) j = p[j - 1];
        if (s[i] == s[j]) ++j;
        p[i] = j;
    }
    return p;
}


//============================================================================================================================================================================================================

void solve() {
    /*int n, c;
    cin >> n >> c;
    f[0] = 1;
    for (int i = 1; i < N; ++i) {
        f[i] = f[i - 1] * i % mod;
    }
    vector<int> lp(c + 1), pr, ord(c + 1);
    for (int i = 2; i <= c; ++i) {
        if (!lp[i]) {
            lp[i] = i;
            ord[i] = 1;
            pr.push_back(i);
        }
        for (auto p : pr) {
            if (p > lp[i] || 1ll * p * i > c) break;
            lp[p * i] = p;
            if (p == lp[i]) {
                ord[p * i] = ord[i] + 1;
            } else {
                ord[p * i] = 1;
            }
        }
    }
    vector<ll> F(c + 1);
    f[1] = 1;
    ll ans = 1;
    for (int i = 2; i <= c; ++i) {
        f[i] = f[i / bpow(lp[i], ord[i], 1e18)] * C(n, ord[i]) % mod;
        ans += f[i];
    }
    cout << ans % mod;*/
    ll a, b, k, l;
    cin >> a >> b >> k >> l;
    a %= b;
    mystring s;
    int cnt = 25000000;
    while (cnt--) {
        a *= 10;
        s += char(a / b + '0');
        a %= b;
    }
    int n = s.size();
    --k;
    if (k + l <= 25e6) {
        for (int i = k; i < k + l; ++i) {
            cout << s[i];
        }
        return;
    }
    s.reverse();
    string P = "";
    int per = -1;
    for (int p = 1; p < n; ++p) {
        bool f = false;
        for (int i = p * 2 - 1; i < n; ++i) {
            if (i >= n - 5000000) {
                per = p;
                f = true;
                for (int j = 0; j < p; ++j) P += s[j];
                reverse(P.begin(), P.end());
                break;
            }
            if (s[i] != s[i % p]) {
                break;
            }
        }
        if (f) break;
    }
    ll notper = n % per;
    k -= notper;
    k %= per;
    string ans = "";
    for (; l--; k = (k + 1) % per) ans += P[k];
    cout << ans;
}

//============================================================================================================================================================================================================

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("coloring.in", "r", stdin);
    //freopen("coloring.out", "w", stdout);

    //ld time1 = clock();

    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
        cout.flush();
    }

    //ld time2 = clock();
    //cerr << "\n\nTIME: " << (time2 - time1) / CLOCKS_PER_SEC;
    return 0;
}
